Loading...
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0-only
3
4# Copyright (C) 2006 Paul Mackerras, IBM Corporation <paulus@samba.org>
5
6# This script takes a kernel binary and optionally an initrd image
7# and/or a device-tree blob, and creates a bootable zImage for a
8# given platform.
9
10# Options:
11# -o zImage specify output file
12# -p platform specify platform (links in $platform.o)
13# -i initrd specify initrd file
14# -d devtree specify device-tree blob
15# -s tree.dts specify device-tree source file (needs dtc installed)
16# -e esm_blob specify ESM blob for secure images
17# -c cache $kernel.strip.gz (use if present & newer, else make)
18# -C prefix specify command prefix for cross-building tools
19# (strip, objcopy, ld)
20# -D dir specify directory containing data files used by script
21# (default ./arch/powerpc/boot)
22# -W dir specify working directory for temporary files (default .)
23# -z use gzip (legacy)
24# -Z zsuffix compression to use (gz, xz or none)
25
26# Stop execution if any command fails
27set -e
28
29export LC_ALL=C
30
31# Allow for verbose output
32if [ "$V" = 1 ]; then
33 set -x
34 map="-Map wrapper.map"
35fi
36
37# defaults
38kernel=
39ofile=zImage
40platform=of
41initrd=
42dtb=
43dts=
44esm_blob=
45cacheit=
46binary=
47compression=.gz
48uboot_comp=gzip
49pie=
50format=
51notext=
52rodynamic=
53
54# cross-compilation prefix
55CROSS=
56
57# mkimage wrapper script
58MKIMAGE=$srctree/scripts/mkuboot.sh
59
60# directory for object and other files used by this script
61object=arch/powerpc/boot
62objbin=$object
63dtc=scripts/dtc/dtc
64
65# directory for working files
66tmpdir=.
67
68usage() {
69 echo 'Usage: wrapper [-o output] [-p platform] [-i initrd]' >&2
70 echo ' [-d devtree] [-s tree.dts] [-e esm_blob]' >&2
71 echo ' [-c] [-C cross-prefix] [-D datadir] [-W workingdir]' >&2
72 echo ' [-Z (gz|xz|none)] [--no-compression] [vmlinux]' >&2
73 exit 1
74}
75
76run_cmd() {
77 if [ "$V" = 1 ]; then
78 $* 2>&1
79 else
80 local msg
81
82 set +e
83 msg=$($* 2>&1)
84
85 if [ $? -ne "0" ]; then
86 echo $msg
87 exit 1
88 fi
89 set -e
90 fi
91}
92
93while [ "$#" -gt 0 ]; do
94 case "$1" in
95 -o)
96 shift
97 [ "$#" -gt 0 ] || usage
98 ofile="$1"
99 ;;
100 -p)
101 shift
102 [ "$#" -gt 0 ] || usage
103 platform="$1"
104 ;;
105 -i)
106 shift
107 [ "$#" -gt 0 ] || usage
108 initrd="$1"
109 ;;
110 -d)
111 shift
112 [ "$#" -gt 0 ] || usage
113 dtb="$1"
114 ;;
115 -e)
116 shift
117 [ "$#" -gt 0 ] || usage
118 esm_blob="$1"
119 ;;
120 -s)
121 shift
122 [ "$#" -gt 0 ] || usage
123 dts="$1"
124 ;;
125 -c)
126 cacheit=y
127 ;;
128 -C)
129 shift
130 [ "$#" -gt 0 ] || usage
131 CROSS="$1"
132 ;;
133 -D)
134 shift
135 [ "$#" -gt 0 ] || usage
136 object="$1"
137 objbin="$1"
138 ;;
139 -W)
140 shift
141 [ "$#" -gt 0 ] || usage
142 tmpdir="$1"
143 ;;
144 -z)
145 compression=.gz
146 uboot_comp=gzip
147 ;;
148 -Z)
149 shift
150 [ "$#" -gt 0 ] || usage
151 [ "$1" != "gz" -o "$1" != "xz" -o "$1" != "lzma" -o "$1" != "lzo" -o "$1" != "none" ] || usage
152
153 compression=".$1"
154 uboot_comp=$1
155
156 if [ $compression = ".none" ]; then
157 compression=
158 uboot_comp=none
159 fi
160 if [ $uboot_comp = "gz" ]; then
161 uboot_comp=gzip
162 fi
163 ;;
164 --no-gzip)
165 # a "feature" of the wrapper script is that it can be used outside
166 # the kernel tree. So keeping this around for backwards compatibility.
167 compression=
168 uboot_comp=none
169 ;;
170 -?)
171 usage
172 ;;
173 *)
174 [ -z "$kernel" ] || usage
175 kernel="$1"
176 ;;
177 esac
178 shift
179done
180
181
182if [ -n "$dts" ]; then
183 if [ ! -r "$dts" -a -r "$object/dts/$dts" ]; then
184 dts="$object/dts/$dts"
185 fi
186 if [ -z "$dtb" ]; then
187 dtb="$platform.dtb"
188 fi
189 $dtc -O dtb -o "$dtb" -b 0 "$dts"
190fi
191
192if [ -z "$kernel" ]; then
193 kernel=vmlinux
194fi
195
196LC_ALL=C elfformat="`${CROSS}objdump -p "$kernel" | grep 'file format' | awk '{print $4}'`"
197case "$elfformat" in
198 elf64-powerpcle) format=elf64lppc ;;
199 elf64-powerpc) format=elf32ppc ;;
200 elf32-powerpc) format=elf32ppc ;;
201esac
202
203ld_version()
204{
205 # Poached from scripts/ld-version.sh, but we don't want to call that because
206 # this script (wrapper) is distributed separately from the kernel source.
207 # Extract linker version number from stdin and turn into single number.
208 awk '{
209 gsub(".*\\)", "");
210 gsub(".*version ", "");
211 gsub("-.*", "");
212 split($1,a, ".");
213 if( length(a[3]) == "8" )
214 # a[3] is probably a date of format yyyymmdd used for release snapshots. We
215 # can assume it to be zero as it does not signify a new version as such.
216 a[3] = 0;
217 print a[1]*100000000 + a[2]*1000000 + a[3]*10000;
218 exit
219 }'
220}
221
222ld_is_lld()
223{
224 ${CROSS}ld -V 2>&1 | grep -q LLD
225}
226
227# Do not include PT_INTERP segment when linking pie. Non-pie linking
228# just ignores this option.
229LD_VERSION=$(${CROSS}ld --version | ld_version)
230LD_NO_DL_MIN_VERSION=$(echo 2.26 | ld_version)
231if [ "$LD_VERSION" -ge "$LD_NO_DL_MIN_VERSION" ] ; then
232 nodl="--no-dynamic-linker"
233fi
234
235# suppress some warnings in recent ld versions
236nowarn="-z noexecstack"
237if ! ld_is_lld; then
238 if [ "$LD_VERSION" -ge "$(echo 2.39 | ld_version)" ]; then
239 nowarn="$nowarn --no-warn-rwx-segments"
240 fi
241fi
242
243platformo=$object/"$platform".o
244lds=$object/zImage.lds
245ext=strip
246objflags=-S
247tmp=$tmpdir/zImage.$$.o
248ksection=.kernel:vmlinux.strip
249isection=.kernel:initrd
250esection=.kernel:esm_blob
251link_address='0x400000'
252make_space=y
253
254
255if [ -n "$esm_blob" -a "$platform" != "pseries" ]; then
256 echo "ESM blob not support on non-pseries platforms" >&2
257 exit 1
258fi
259
260case "$platform" in
261of)
262 platformo="$object/of.o $object/epapr.o"
263 make_space=n
264 ;;
265pseries)
266 platformo="$object/pseries-head.o $object/of.o $object/epapr.o"
267 link_address='0x4000000'
268 if [ "$format" != "elf32ppc" ]; then
269 link_address=
270 pie=-pie
271 fi
272 make_space=n
273 ;;
274pmac|chrp)
275 platformo="$object/of.o $object/epapr.o"
276 make_space=n
277 ;;
278coff)
279 platformo="$object/crt0.o $object/of.o $object/epapr.o"
280 lds=$object/zImage.coff.lds
281 link_address='0x500000'
282 make_space=n
283 pie=
284 ;;
285miboot|uboot*)
286 # miboot and U-boot want just the bare bits, not an ELF binary
287 ext=bin
288 objflags="-O binary"
289 tmp="$ofile"
290 ksection=image
291 isection=initrd
292 ;;
293cuboot*)
294 binary=y
295 compression=
296 case "$platform" in
297 *-mpc866ads|*-mpc885ads|*-adder875*|*-ep88xc)
298 platformo=$object/cuboot-8xx.o
299 ;;
300 *5200*|*-motionpro)
301 platformo=$object/cuboot-52xx.o
302 ;;
303 *-pq2fads|*-ep8248e|*-mpc8272*|*-storcenter)
304 platformo=$object/cuboot-pq2.o
305 ;;
306 *-mpc824*)
307 platformo=$object/cuboot-824x.o
308 ;;
309 *-mpc83*|*-asp834x*)
310 platformo=$object/cuboot-83xx.o
311 ;;
312 *-tqm8541|*-mpc8560*|*-tqm8560|*-tqm8555|*-ksi8560*)
313 platformo=$object/cuboot-85xx-cpm2.o
314 ;;
315 *-mpc85*|*-tqm85*)
316 platformo=$object/cuboot-85xx.o
317 ;;
318 *-amigaone)
319 link_address='0x800000'
320 ;;
321 esac
322 ;;
323ps3)
324 platformo="$object/ps3-head.o $object/ps3-hvcall.o $object/ps3.o"
325 lds=$object/zImage.ps3.lds
326 compression=
327 ext=bin
328 objflags="-O binary --set-section-flags=.bss=contents,alloc,load,data"
329 ksection=.kernel:vmlinux.bin
330 isection=.kernel:initrd
331 link_address=''
332 make_space=n
333 pie=
334 ;;
335ep88xc|ep8248e)
336 platformo="$object/fixed-head.o $object/$platform.o"
337 binary=y
338 ;;
339adder875-redboot)
340 platformo="$object/fixed-head.o $object/redboot-8xx.o"
341 binary=y
342 ;;
343simpleboot-*)
344 platformo="$object/fixed-head.o $object/simpleboot.o"
345 binary=y
346 ;;
347asp834x-redboot)
348 platformo="$object/fixed-head.o $object/redboot-83xx.o"
349 binary=y
350 ;;
351xpedite52*)
352 link_address='0x1400000'
353 platformo=$object/cuboot-85xx.o
354 ;;
355gamecube|wii)
356 link_address='0x600000'
357 platformo="$object/$platform-head.o $object/$platform.o"
358 ;;
359microwatt)
360 link_address='0x500000'
361 platformo="$object/fixed-head.o $object/$platform.o"
362 binary=y
363 ;;
364treeboot-currituck)
365 link_address='0x1000000'
366 ;;
367treeboot-akebono)
368 link_address='0x1000000'
369 ;;
370treeboot-iss4xx-mpic)
371 platformo="$object/treeboot-iss4xx.o"
372 ;;
373epapr)
374 platformo="$object/pseries-head.o $object/epapr.o $object/epapr-wrapper.o"
375 link_address='0x20000000'
376 pie=-pie
377 notext='-z notext'
378 rodynamic=$(if ${CROSS}ld -V 2>&1 | grep -q LLD ; then echo "-z rodynamic"; fi)
379 ;;
380mvme5100)
381 platformo="$object/fixed-head.o $object/mvme5100.o"
382 binary=y
383 ;;
384mvme7100)
385 platformo="$object/motload-head.o $object/mvme7100.o"
386 link_address='0x4000000'
387 binary=y
388 ;;
389esac
390
391vmz="$tmpdir/`basename \"$kernel\"`.$ext"
392
393# Calculate the vmlinux.strip size
394${CROSS}objcopy $objflags "$kernel" "$vmz.$$"
395strip_size=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" "$vmz.$$")
396
397if [ -z "$cacheit" -o ! -f "$vmz$compression" -o "$vmz$compression" -ot "$kernel" ]; then
398 # recompress the image if we need to
399 case $compression in
400 .xz)
401 xz --check=crc32 -f -6 "$vmz.$$"
402 ;;
403 .gz)
404 gzip -n -f -9 "$vmz.$$"
405 ;;
406 .lzma)
407 xz --format=lzma -f -6 "$vmz.$$"
408 ;;
409 .lzo)
410 lzop -f -9 "$vmz.$$"
411 ;;
412 *)
413 # drop the compression suffix so the stripped vmlinux is used
414 compression=
415 uboot_comp=none
416 ;;
417 esac
418
419 if [ -n "$cacheit" ]; then
420 mv -f "$vmz.$$$compression" "$vmz$compression"
421 else
422 vmz="$vmz.$$"
423 fi
424else
425 rm -f $vmz.$$
426fi
427
428vmz="$vmz$compression"
429
430if [ "$make_space" = "y" ]; then
431 # Round the size to next higher MB limit
432 round_size=$(((strip_size + 0xfffff) & 0xfff00000))
433
434 round_size=0x$(printf "%x" $round_size)
435 link_addr=$(printf "%d" $link_address)
436
437 if [ $link_addr -lt $strip_size ]; then
438 echo "INFO: Uncompressed kernel (size 0x$(printf "%x\n" $strip_size))" \
439 "overlaps the address of the wrapper($link_address)"
440 echo "INFO: Fixing the link_address of wrapper to ($round_size)"
441 link_address=$round_size
442 fi
443fi
444
445# Extract kernel version information, some platforms want to include
446# it in the image header
447version=`${CROSS}strings "$kernel" | grep '^Linux version [-0-9.]' | \
448 head -n1 | cut -d' ' -f3`
449if [ -n "$version" ]; then
450 uboot_version="-n Linux-$version"
451fi
452
453# physical offset of kernel image
454membase=`${CROSS}objdump -p "$kernel" | grep -m 1 LOAD | awk '{print $7}'`
455
456case "$platform" in
457uboot)
458 rm -f "$ofile"
459 ${MKIMAGE} -A ppc -O linux -T kernel -C $uboot_comp -a $membase -e $membase \
460 $uboot_version -d "$vmz" "$ofile"
461 if [ -z "$cacheit" ]; then
462 rm -f "$vmz"
463 fi
464 exit 0
465 ;;
466esac
467
468addsec() {
469 ${CROSS}objcopy $4 $1 \
470 --add-section=$3="$2" \
471 --set-section-flags=$3=contents,alloc,load,readonly,data
472}
473
474addsec $tmp "$vmz" $ksection $object/empty.o
475if [ -z "$cacheit" ]; then
476 rm -f "$vmz"
477fi
478
479if [ -n "$initrd" ]; then
480 addsec $tmp "$initrd" $isection
481fi
482
483if [ -n "$dtb" ]; then
484 addsec $tmp "$dtb" .kernel:dtb
485 if [ -n "$dts" ]; then
486 rm $dtb
487 fi
488fi
489
490if [ -n "$esm_blob" ]; then
491 addsec $tmp "$esm_blob" $esection
492fi
493
494if [ "$platform" != "miboot" ]; then
495 if [ -n "$link_address" ] ; then
496 text_start="-Ttext $link_address"
497 fi
498#link everything
499 ${CROSS}ld -m $format -T $lds $text_start $pie $nodl $nowarn $rodynamic $notext -o "$ofile" $map \
500 $platformo $tmp $object/wrapper.a
501 rm $tmp
502fi
503
504# Some platforms need the zImage's entry point and base address
505base=0x`${CROSS}nm "$ofile" | grep ' _start$' | cut -d' ' -f1`
506entry=`${CROSS}objdump -f "$ofile" | grep '^start address ' | cut -d' ' -f3`
507
508if [ -n "$binary" ]; then
509 mv "$ofile" "$ofile".elf
510 ${CROSS}objcopy -O binary "$ofile".elf "$ofile"
511fi
512
513# post-processing needed for some platforms
514case "$platform" in
515pseries|chrp)
516 $objbin/addnote "$ofile"
517 ;;
518coff)
519 ${CROSS}objcopy -O aixcoff-rs6000 --set-start "$entry" "$ofile"
520 $objbin/hack-coff "$ofile"
521 ;;
522cuboot*)
523 gzip -n -f -9 "$ofile"
524 ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a "$base" -e "$entry" \
525 $uboot_version -d "$ofile".gz "$ofile"
526 ;;
527treeboot*)
528 mv "$ofile" "$ofile.elf"
529 $objbin/mktree "$ofile.elf" "$ofile" "$base" "$entry"
530 if [ -z "$cacheit" ]; then
531 rm -f "$ofile.elf"
532 fi
533 exit 0
534 ;;
535ps3)
536 # The ps3's loader supports loading a gzipped binary image from flash
537 # rom to ram addr zero. The loader then enters the system reset
538 # vector at addr 0x100. A bootwrapper overlay is used to arrange for
539 # a binary image of the kernel to be at addr zero, and yet have a
540 # suitable bootwrapper entry at 0x100. To construct the final rom
541 # image 512 bytes from offset 0x100 is copied to the bootwrapper
542 # place holder at symbol __system_reset_kernel. The 512 bytes of the
543 # bootwrapper entry code at symbol __system_reset_overlay is then
544 # copied to offset 0x100. At runtime the bootwrapper program copies
545 # the data at __system_reset_kernel back to addr 0x100.
546
547 system_reset_overlay=0x`${CROSS}nm "$ofile" \
548 | grep ' __system_reset_overlay$' \
549 | cut -d' ' -f1`
550 system_reset_overlay=`printf "%d" $system_reset_overlay`
551 system_reset_kernel=0x`${CROSS}nm "$ofile" \
552 | grep ' __system_reset_kernel$' \
553 | cut -d' ' -f1`
554 system_reset_kernel=`printf "%d" $system_reset_kernel`
555 overlay_dest="256"
556 overlay_size="512"
557
558 ${CROSS}objcopy -O binary "$ofile" "$ofile.bin"
559
560 run_cmd dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
561 skip=$overlay_dest seek=$system_reset_kernel \
562 count=$overlay_size bs=1
563
564 run_cmd dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
565 skip=$system_reset_overlay seek=$overlay_dest \
566 count=$overlay_size bs=1
567
568 odir="$(dirname "$ofile.bin")"
569
570 # The ps3's flash loader has a size limit of 16 MiB for the uncompressed
571 # image. If a compressed image that exceeded this limit is written to
572 # flash the loader will decompress that image until the 16 MiB limit is
573 # reached, then enter the system reset vector of the partially decompressed
574 # image. No warning is issued.
575 rm -f "$odir"/{otheros,otheros-too-big}.bld
576 size=$(${CROSS}nm --no-sort --radix=d "$ofile" | grep -E ' _end$' | cut -d' ' -f1)
577 bld="otheros.bld"
578 if [ $size -gt $((0x1000000)) ]; then
579 bld="otheros-too-big.bld"
580 fi
581 gzip -n --force -9 --stdout "$ofile.bin" > "$odir/$bld"
582 ;;
583esac
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0-only
3
4# Copyright (C) 2006 Paul Mackerras, IBM Corporation <paulus@samba.org>
5
6# This script takes a kernel binary and optionally an initrd image
7# and/or a device-tree blob, and creates a bootable zImage for a
8# given platform.
9
10# Options:
11# -o zImage specify output file
12# -p platform specify platform (links in $platform.o)
13# -i initrd specify initrd file
14# -d devtree specify device-tree blob
15# -s tree.dts specify device-tree source file (needs dtc installed)
16# -e esm_blob specify ESM blob for secure images
17# -c cache $kernel.strip.gz (use if present & newer, else make)
18# -C prefix specify command prefix for cross-building tools
19# (strip, objcopy, ld)
20# -D dir specify directory containing data files used by script
21# (default ./arch/powerpc/boot)
22# -W dir specify working directory for temporary files (default .)
23# -z use gzip (legacy)
24# -Z zsuffix compression to use (gz, xz or none)
25
26# Stop execution if any command fails
27set -e
28
29# Allow for verbose output
30if [ "$V" = 1 ]; then
31 set -x
32 map="-Map wrapper.map"
33fi
34
35# defaults
36kernel=
37ofile=zImage
38platform=of
39initrd=
40dtb=
41dts=
42esm_blob=
43cacheit=
44binary=
45compression=.gz
46uboot_comp=gzip
47pie=
48format=
49notext=
50rodynamic=
51
52# cross-compilation prefix
53CROSS=
54
55# mkimage wrapper script
56MKIMAGE=$srctree/scripts/mkuboot.sh
57
58# directory for object and other files used by this script
59object=arch/powerpc/boot
60objbin=$object
61dtc=scripts/dtc/dtc
62
63# directory for working files
64tmpdir=.
65
66usage() {
67 echo 'Usage: wrapper [-o output] [-p platform] [-i initrd]' >&2
68 echo ' [-d devtree] [-s tree.dts] [-e esm_blob]' >&2
69 echo ' [-c] [-C cross-prefix] [-D datadir] [-W workingdir]' >&2
70 echo ' [-Z (gz|xz|none)] [--no-compression] [vmlinux]' >&2
71 exit 1
72}
73
74run_cmd() {
75 if [ "$V" = 1 ]; then
76 $* 2>&1
77 else
78 local msg
79
80 set +e
81 msg=$($* 2>&1)
82
83 if [ $? -ne "0" ]; then
84 echo $msg
85 exit 1
86 fi
87 set -e
88 fi
89}
90
91while [ "$#" -gt 0 ]; do
92 case "$1" in
93 -o)
94 shift
95 [ "$#" -gt 0 ] || usage
96 ofile="$1"
97 ;;
98 -p)
99 shift
100 [ "$#" -gt 0 ] || usage
101 platform="$1"
102 ;;
103 -i)
104 shift
105 [ "$#" -gt 0 ] || usage
106 initrd="$1"
107 ;;
108 -d)
109 shift
110 [ "$#" -gt 0 ] || usage
111 dtb="$1"
112 ;;
113 -e)
114 shift
115 [ "$#" -gt 0 ] || usage
116 esm_blob="$1"
117 ;;
118 -s)
119 shift
120 [ "$#" -gt 0 ] || usage
121 dts="$1"
122 ;;
123 -c)
124 cacheit=y
125 ;;
126 -C)
127 shift
128 [ "$#" -gt 0 ] || usage
129 CROSS="$1"
130 ;;
131 -D)
132 shift
133 [ "$#" -gt 0 ] || usage
134 object="$1"
135 objbin="$1"
136 ;;
137 -W)
138 shift
139 [ "$#" -gt 0 ] || usage
140 tmpdir="$1"
141 ;;
142 -z)
143 compression=.gz
144 uboot_comp=gzip
145 ;;
146 -Z)
147 shift
148 [ "$#" -gt 0 ] || usage
149 [ "$1" != "gz" -o "$1" != "xz" -o "$1" != "lzma" -o "$1" != "lzo" -o "$1" != "none" ] || usage
150
151 compression=".$1"
152 uboot_comp=$1
153
154 if [ $compression = ".none" ]; then
155 compression=
156 uboot_comp=none
157 fi
158 if [ $uboot_comp = "gz" ]; then
159 uboot_comp=gzip
160 fi
161 ;;
162 --no-gzip)
163 # a "feature" of the the wrapper script is that it can be used outside
164 # the kernel tree. So keeping this around for backwards compatibility.
165 compression=
166 uboot_comp=none
167 ;;
168 -?)
169 usage
170 ;;
171 *)
172 [ -z "$kernel" ] || usage
173 kernel="$1"
174 ;;
175 esac
176 shift
177done
178
179
180if [ -n "$dts" ]; then
181 if [ ! -r "$dts" -a -r "$object/dts/$dts" ]; then
182 dts="$object/dts/$dts"
183 fi
184 if [ -z "$dtb" ]; then
185 dtb="$platform.dtb"
186 fi
187 $dtc -O dtb -o "$dtb" -b 0 "$dts"
188fi
189
190if [ -z "$kernel" ]; then
191 kernel=vmlinux
192fi
193
194LC_ALL=C elfformat="`${CROSS}objdump -p "$kernel" | grep 'file format' | awk '{print $4}'`"
195case "$elfformat" in
196 elf64-powerpcle) format=elf64lppc ;;
197 elf64-powerpc) format=elf32ppc ;;
198 elf32-powerpc) format=elf32ppc ;;
199esac
200
201ld_version()
202{
203 # Poached from scripts/ld-version.sh, but we don't want to call that because
204 # this script (wrapper) is distributed separately from the kernel source.
205 # Extract linker version number from stdin and turn into single number.
206 awk '{
207 gsub(".*\\)", "");
208 gsub(".*version ", "");
209 gsub("-.*", "");
210 split($1,a, ".");
211 print a[1]*100000000 + a[2]*1000000 + a[3]*10000;
212 exit
213 }'
214}
215
216# Do not include PT_INTERP segment when linking pie. Non-pie linking
217# just ignores this option.
218LD_VERSION=$(${CROSS}ld --version | ld_version)
219LD_NO_DL_MIN_VERSION=$(echo 2.26 | ld_version)
220if [ "$LD_VERSION" -ge "$LD_NO_DL_MIN_VERSION" ] ; then
221 nodl="--no-dynamic-linker"
222fi
223
224platformo=$object/"$platform".o
225lds=$object/zImage.lds
226ext=strip
227objflags=-S
228tmp=$tmpdir/zImage.$$.o
229ksection=.kernel:vmlinux.strip
230isection=.kernel:initrd
231esection=.kernel:esm_blob
232link_address='0x400000'
233make_space=y
234
235
236if [ -n "$esm_blob" -a "$platform" != "pseries" ]; then
237 echo "ESM blob not support on non-pseries platforms" >&2
238 exit 1
239fi
240
241case "$platform" in
242of)
243 platformo="$object/of.o $object/epapr.o"
244 make_space=n
245 ;;
246pseries)
247 platformo="$object/pseries-head.o $object/of.o $object/epapr.o"
248 link_address='0x4000000'
249 if [ "$format" != "elf32ppc" ]; then
250 link_address=
251 pie=-pie
252 fi
253 make_space=n
254 ;;
255maple)
256 platformo="$object/of.o $object/epapr.o"
257 link_address='0x400000'
258 make_space=n
259 ;;
260pmac|chrp)
261 platformo="$object/of.o $object/epapr.o"
262 make_space=n
263 ;;
264coff)
265 platformo="$object/crt0.o $object/of.o $object/epapr.o"
266 lds=$object/zImage.coff.lds
267 link_address='0x500000'
268 make_space=n
269 pie=
270 ;;
271miboot|uboot*)
272 # miboot and U-boot want just the bare bits, not an ELF binary
273 ext=bin
274 objflags="-O binary"
275 tmp="$ofile"
276 ksection=image
277 isection=initrd
278 ;;
279cuboot*)
280 binary=y
281 compression=
282 case "$platform" in
283 *-mpc866ads|*-mpc885ads|*-adder875*|*-ep88xc)
284 platformo=$object/cuboot-8xx.o
285 ;;
286 *5200*|*-motionpro)
287 platformo=$object/cuboot-52xx.o
288 ;;
289 *-pq2fads|*-ep8248e|*-mpc8272*|*-storcenter)
290 platformo=$object/cuboot-pq2.o
291 ;;
292 *-mpc824*)
293 platformo=$object/cuboot-824x.o
294 ;;
295 *-mpc83*|*-asp834x*)
296 platformo=$object/cuboot-83xx.o
297 ;;
298 *-tqm8541|*-mpc8560*|*-tqm8560|*-tqm8555|*-ksi8560*)
299 platformo=$object/cuboot-85xx-cpm2.o
300 ;;
301 *-mpc85*|*-tqm85*|*-sbc85*)
302 platformo=$object/cuboot-85xx.o
303 ;;
304 *-amigaone)
305 link_address='0x800000'
306 ;;
307 esac
308 ;;
309ps3)
310 platformo="$object/ps3-head.o $object/ps3-hvcall.o $object/ps3.o"
311 lds=$object/zImage.ps3.lds
312 compression=
313 ext=bin
314 objflags="-O binary --set-section-flags=.bss=contents,alloc,load,data"
315 ksection=.kernel:vmlinux.bin
316 isection=.kernel:initrd
317 link_address=''
318 make_space=n
319 pie=
320 ;;
321ep88xc|ep405|ep8248e)
322 platformo="$object/fixed-head.o $object/$platform.o"
323 binary=y
324 ;;
325adder875-redboot)
326 platformo="$object/fixed-head.o $object/redboot-8xx.o"
327 binary=y
328 ;;
329simpleboot-*)
330 platformo="$object/fixed-head.o $object/simpleboot.o"
331 binary=y
332 ;;
333asp834x-redboot)
334 platformo="$object/fixed-head.o $object/redboot-83xx.o"
335 binary=y
336 ;;
337xpedite52*)
338 link_address='0x1400000'
339 platformo=$object/cuboot-85xx.o
340 ;;
341gamecube|wii)
342 link_address='0x600000'
343 platformo="$object/$platform-head.o $object/$platform.o"
344 ;;
345microwatt)
346 link_address='0x500000'
347 platformo="$object/fixed-head.o $object/$platform.o"
348 binary=y
349 ;;
350treeboot-currituck)
351 link_address='0x1000000'
352 ;;
353treeboot-akebono)
354 link_address='0x1000000'
355 ;;
356treeboot-iss4xx-mpic)
357 platformo="$object/treeboot-iss4xx.o"
358 ;;
359epapr)
360 platformo="$object/pseries-head.o $object/epapr.o $object/epapr-wrapper.o"
361 link_address='0x20000000'
362 pie=-pie
363 notext='-z notext'
364 rodynamic=$(if ${CROSS}ld -V 2>&1 | grep -q LLD ; then echo "-z rodynamic"; fi)
365 ;;
366mvme5100)
367 platformo="$object/fixed-head.o $object/mvme5100.o"
368 binary=y
369 ;;
370mvme7100)
371 platformo="$object/motload-head.o $object/mvme7100.o"
372 link_address='0x4000000'
373 binary=y
374 ;;
375esac
376
377vmz="$tmpdir/`basename \"$kernel\"`.$ext"
378
379# Calculate the vmlinux.strip size
380${CROSS}objcopy $objflags "$kernel" "$vmz.$$"
381strip_size=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" "$vmz.$$")
382
383if [ -z "$cacheit" -o ! -f "$vmz$compression" -o "$vmz$compression" -ot "$kernel" ]; then
384 # recompress the image if we need to
385 case $compression in
386 .xz)
387 xz --check=crc32 -f -6 "$vmz.$$"
388 ;;
389 .gz)
390 gzip -n -f -9 "$vmz.$$"
391 ;;
392 .lzma)
393 xz --format=lzma -f -6 "$vmz.$$"
394 ;;
395 .lzo)
396 lzop -f -9 "$vmz.$$"
397 ;;
398 *)
399 # drop the compression suffix so the stripped vmlinux is used
400 compression=
401 uboot_comp=none
402 ;;
403 esac
404
405 if [ -n "$cacheit" ]; then
406 mv -f "$vmz.$$$compression" "$vmz$compression"
407 else
408 vmz="$vmz.$$"
409 fi
410else
411 rm -f $vmz.$$
412fi
413
414vmz="$vmz$compression"
415
416if [ "$make_space" = "y" ]; then
417 # Round the size to next higher MB limit
418 round_size=$(((strip_size + 0xfffff) & 0xfff00000))
419
420 round_size=0x$(printf "%x" $round_size)
421 link_addr=$(printf "%d" $link_address)
422
423 if [ $link_addr -lt $strip_size ]; then
424 echo "INFO: Uncompressed kernel (size 0x$(printf "%x\n" $strip_size))" \
425 "overlaps the address of the wrapper($link_address)"
426 echo "INFO: Fixing the link_address of wrapper to ($round_size)"
427 link_address=$round_size
428 fi
429fi
430
431# Extract kernel version information, some platforms want to include
432# it in the image header
433version=`${CROSS}strings "$kernel" | grep '^Linux version [-0-9.]' | \
434 cut -d' ' -f3`
435if [ -n "$version" ]; then
436 uboot_version="-n Linux-$version"
437fi
438
439# physical offset of kernel image
440membase=`${CROSS}objdump -p "$kernel" | grep -m 1 LOAD | awk '{print $7}'`
441
442case "$platform" in
443uboot)
444 rm -f "$ofile"
445 ${MKIMAGE} -A ppc -O linux -T kernel -C $uboot_comp -a $membase -e $membase \
446 $uboot_version -d "$vmz" "$ofile"
447 if [ -z "$cacheit" ]; then
448 rm -f "$vmz"
449 fi
450 exit 0
451 ;;
452uboot-obs600)
453 rm -f "$ofile"
454 # obs600 wants a multi image with an initrd, so we need to put a fake
455 # one in even when building a "normal" image.
456 if [ -n "$initrd" ]; then
457 real_rd="$initrd"
458 else
459 real_rd=`mktemp`
460 echo "\0" >>"$real_rd"
461 fi
462 ${MKIMAGE} -A ppc -O linux -T multi -C gzip -a $membase -e $membase \
463 $uboot_version -d "$vmz":"$real_rd":"$dtb" "$ofile"
464 if [ -z "$initrd" ]; then
465 rm -f "$real_rd"
466 fi
467 if [ -z "$cacheit" ]; then
468 rm -f "$vmz"
469 fi
470 exit 0
471 ;;
472esac
473
474addsec() {
475 ${CROSS}objcopy $4 $1 \
476 --add-section=$3="$2" \
477 --set-section-flags=$3=contents,alloc,load,readonly,data
478}
479
480addsec $tmp "$vmz" $ksection $object/empty.o
481if [ -z "$cacheit" ]; then
482 rm -f "$vmz"
483fi
484
485if [ -n "$initrd" ]; then
486 addsec $tmp "$initrd" $isection
487fi
488
489if [ -n "$dtb" ]; then
490 addsec $tmp "$dtb" .kernel:dtb
491 if [ -n "$dts" ]; then
492 rm $dtb
493 fi
494fi
495
496if [ -n "$esm_blob" ]; then
497 addsec $tmp "$esm_blob" $esection
498fi
499
500if [ "$platform" != "miboot" ]; then
501 if [ -n "$link_address" ] ; then
502 text_start="-Ttext $link_address"
503 fi
504#link everything
505 ${CROSS}ld -m $format -T $lds $text_start $pie $nodl $rodynamic $notext -o "$ofile" $map \
506 $platformo $tmp $object/wrapper.a
507 rm $tmp
508fi
509
510# Some platforms need the zImage's entry point and base address
511base=0x`${CROSS}nm "$ofile" | grep ' _start$' | cut -d' ' -f1`
512entry=`${CROSS}objdump -f "$ofile" | grep '^start address ' | cut -d' ' -f3`
513
514if [ -n "$binary" ]; then
515 mv "$ofile" "$ofile".elf
516 ${CROSS}objcopy -O binary "$ofile".elf "$ofile"
517fi
518
519# post-processing needed for some platforms
520case "$platform" in
521pseries|chrp|maple)
522 $objbin/addnote "$ofile"
523 ;;
524coff)
525 ${CROSS}objcopy -O aixcoff-rs6000 --set-start "$entry" "$ofile"
526 $objbin/hack-coff "$ofile"
527 ;;
528cuboot*)
529 gzip -n -f -9 "$ofile"
530 ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a "$base" -e "$entry" \
531 $uboot_version -d "$ofile".gz "$ofile"
532 ;;
533treeboot*)
534 mv "$ofile" "$ofile.elf"
535 $objbin/mktree "$ofile.elf" "$ofile" "$base" "$entry"
536 if [ -z "$cacheit" ]; then
537 rm -f "$ofile.elf"
538 fi
539 exit 0
540 ;;
541ps3)
542 # The ps3's loader supports loading a gzipped binary image from flash
543 # rom to ram addr zero. The loader then enters the system reset
544 # vector at addr 0x100. A bootwrapper overlay is used to arrange for
545 # a binary image of the kernel to be at addr zero, and yet have a
546 # suitable bootwrapper entry at 0x100. To construct the final rom
547 # image 512 bytes from offset 0x100 is copied to the bootwrapper
548 # place holder at symbol __system_reset_kernel. The 512 bytes of the
549 # bootwrapper entry code at symbol __system_reset_overlay is then
550 # copied to offset 0x100. At runtime the bootwrapper program copies
551 # the data at __system_reset_kernel back to addr 0x100.
552
553 system_reset_overlay=0x`${CROSS}nm "$ofile" \
554 | grep ' __system_reset_overlay$' \
555 | cut -d' ' -f1`
556 system_reset_overlay=`printf "%d" $system_reset_overlay`
557 system_reset_kernel=0x`${CROSS}nm "$ofile" \
558 | grep ' __system_reset_kernel$' \
559 | cut -d' ' -f1`
560 system_reset_kernel=`printf "%d" $system_reset_kernel`
561 overlay_dest="256"
562 overlay_size="512"
563
564 ${CROSS}objcopy -O binary "$ofile" "$ofile.bin"
565
566 run_cmd dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
567 skip=$overlay_dest seek=$system_reset_kernel \
568 count=$overlay_size bs=1
569
570 run_cmd dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
571 skip=$system_reset_overlay seek=$overlay_dest \
572 count=$overlay_size bs=1
573
574 odir="$(dirname "$ofile.bin")"
575
576 # The ps3's flash loader has a size limit of 16 MiB for the uncompressed
577 # image. If a compressed image that exceeded this limit is written to
578 # flash the loader will decompress that image until the 16 MiB limit is
579 # reached, then enter the system reset vector of the partially decompressed
580 # image. No warning is issued.
581 rm -f "$odir"/{otheros,otheros-too-big}.bld
582 size=$(${CROSS}nm --no-sort --radix=d "$ofile" | egrep ' _end$' | cut -d' ' -f1)
583 bld="otheros.bld"
584 if [ $size -gt $((0x1000000)) ]; then
585 bld="otheros-too-big.bld"
586 fi
587 gzip -n --force -9 --stdout "$ofile.bin" > "$odir/$bld"
588 ;;
589esac